function chatgpt(){
    function uid(){
        const generateNumber = (limit) => {
            const value = limit * Math.random();
            return value | 0;
        }
        const generateX = () => {
            const value = generateNumber(16);
            return value.toString(16);
        }
        const generateXes = (count) => {
            let result = '';
            for(let i = 0; i < count; ++i) {
                result += generateX();
            }
            return result;
        }
        const generateconstant = () => {
            const value = generateNumber(16);
            const constant =  (value & 0x3) | 0x8;
            return constant.toString(16);
        }
            
        const generate = () => {
                    const result = generateXes(8)
                            + '-' + generateXes(4)
                            + '-' + '4' + generateXes(3)
                            + '-' + generateconstant() + generateXes(3)
                            + '-' + generateXes(12)
                    return result;
        };
        return generate()
    }

    let accessToken=null

    return {
        async getToken(){
            if(accessToken){
                return Promise.resolve(accessToken)
            }
            return new Promise(async (resolve, reject) => {
                    const resp = await fetch("https://chat.openai.com/api/auth/session")
                    if (resp.status === 403) {
                        reject('CLOUDFLARE')
                    }
                    try {
                        const data = await resp.json()
                        if (!data.accessToken) {
                            reject('ERROR')
                            return 
                        }

                        Qili.schedule(
                            ()=>accessToken=null,
                            data.expires, 
                            ()=>this.notifyExpiration?.(data.expires),
                            10*60*1000
                        )
                        
                        this.session={token: data.accessToken, expires: data.expires}
                        resolve(accessToken=data.accessToken)
                    } catch (err) {
                        console.error(err)
                        reject('ERROR')
                    }
            })
        },

        async postMessage(message){
            const {messageId=uid(), conversationId}=(msg=>{
				if(typeof(msg)=="string" || !msg.options)
					return {}
				return {}
			})(message);

			const question=message.message||message
			const res = await fetch("https://chat.openai.com/backend-api/conversation", {
					method: "POST",
					headers: {
							"Content-Type": "application/json",
							"Authorization": "Bearer " + (await me.getToken()),
					},
					body: JSON.stringify({
							action: "next",
							messages: [
								{
									id: uid(),
									role: "user",
									content: {
										content_type: "text",
										parts: [question]
									}
								}
							],
							model: "text-davinci-002-render",
							...(conversationId? {conversation_id: conversationId} : {}),
							parent_message_id: messageId,
					})
			})
			return await this.read(res.body)
        },

        async generateTitle(conversationId){
            const res=await fetch(`https://chat.openai.com/backend-api/conversation/gen_title/${conversationId}`,{
                method:"PATCH",
                headers: {
                        "Content-Type": "application/json",
                        "Authorization": "Bearer " + (await this.getToken()),
                },
                body: JSON.stringify({
                    is_visible:false
                })
            })

            return res.json()?.title
        },

        async removeConversation(conversationId){
            const res=await fetch(`https://chat.openai.com/backend-api/conversation/${conversationId}`,{
                method:"PATCH",
                headers: {
                        "Content-Type": "application/json",
                        "Authorization": "Bearer " + (await this.getToken()),
                },
                body: JSON.stringify({
                    is_visible:false
                })
            })

            return res.json()
        },

        async read(answer){
            const resRead = answer.getReader()
            while (true) {
                const {done, value} = await resRead.read()
                if (done) break
                const raw=new TextDecoder().decode(value).split("data:").filter(a=>!!a)
                for(let i=raw.length-1; i>-1; i--){
                    try{
                        const piece=JSON.parse(raw[i])
                        if(piece.message.author.role=="assistant"){
                            if(piece.message.status=="finished_successfully"){
                                return {
                                    message:piece.message.content.parts.join(""), 
                                    messageId:piece.message.id, 
                                    conversationId:piece.conversation_id,
                                    error: piece.error||undefined
                                }
                            }
                            break
                        }
                    }catch(e){
    
                    }
                }
            }
            
            throw new Error("Unknow Error")
        }
    }
}